#pragma once
#include <string>

#define STR_BUFSIZE	1024

class IStrSrc
{
public:
	IStrSrc(void){}
	virtual ~IStrSrc(void){}

public:
	virtual const std::string& GetString(const std::string& sid) = 0;
	virtual const std::string& GetKey(const std::string& value) = 0;
};

class NullStrSrc : public IStrSrc
{
public:
	NullStrSrc(void){}
	virtual ~NullStrSrc(void){}

	virtual const std::string& GetString(const std::string& sid)
	{
		static const std::string nullstr = "";
		return nullstr;
	}

	virtual const std::string& GetKey(const std::string& value)
	{
		static const std::string nullstr = "";
		return nullstr;
	}
};
