#include "mapstring.h"

CMapString::CMapString(void)
{
	InitString();
}

CMapString::~CMapString(void)
{
}

const std::string& CMapString::GetString(const std::string& sid)
{
	static const std::string nullstr = "";
	std::map<std::string, std::string>::iterator iter = m_StrMap.find(sid);
	return iter != m_StrMap.end() ? iter->second : nullstr;
}

const std::string& CMapString::GetKey(const std::string& value)
{
	static const std::string nullstr = "";
	std::map<std::string, std::string>::iterator iter = m_StrMap.begin();
	for(; iter != m_StrMap.end(); ++iter)
		if(iter->second == value)
			return iter->first;

	return nullstr;
}

void CMapString::AddString(const char * Key, const char * Str)
{
	m_StrMap[Key] = Str;
}

void CMapString::AddString(unsigned int Key, const char * Str)
{
	static char keybuffer[STR_BUFSIZE];
	sprintf_s(keybuffer, STR_BUFSIZE, "%d", Key);
	m_StrMap[keybuffer] = Str;
}

CMapString& CMapString::operator()(const char * Key, const char * Str)
{
	AddString(Key, Str);
	return *this;
}


void CMapString::InitString()
{
}

bool CMapString::SetLanguage(std::string lang)
{
    if(m_lang == lang)
        return true;

    for(std::list<OnLangChange_t>::iterator iter = m_beChange.begin();
        iter != m_beChange.end(); ++iter)
        (*iter)(m_lang, lang);

    m_StrMap.clear();
    if(lang == "LANG_CN")
    {
        LoadGb2312();
    }
    else if(lang == "LANG_EN")
    {
        LoadEnglish();
    }

    for(std::list<OnLangChange_t>::iterator iter = m_afChange.begin();
        iter != m_afChange.end(); ++iter)
        (*iter)(m_lang, lang);

    m_lang = lang;
    return true;
}

std::string CMapString::GetLanguage()
{
    return m_lang;
}


void CMapString::HookChange(OnLangChange_t beforeChange , OnLangChange_t afterChange)
{
    if(beforeChange != NULL)
        m_beChange.push_back(beforeChange);

    if(afterChange != NULL)
        m_afChange.push_back(afterChange);
}

void CMapString::UnHookChange(OnLangChange_t beforeChange, OnLangChange_t afterChange)
{
    if(beforeChange != NULL)
        m_beChange.remove(beforeChange);

    if(afterChange != NULL)
        m_afChange.remove(afterChange);
}
