#pragma once
#include "istrsrc.h"
#include <map>
#include <list>

class CMapString :	public IStrSrc
{
public:
	CMapString(void);
	virtual ~CMapString(void);

	const std::string& GetString(const std::string& sid);
	const std::string& GetKey(const std::string& value);

	bool SetLanguage(std::string lang);
	std::string GetLanguage();

    typedef void (*OnLangChange_t)(const std::string& oldlan, const std::string& newlan);
    void HookChange(OnLangChange_t beforeChange = NULL, OnLangChange_t afterChange = NULL);
    void UnHookChange(OnLangChange_t beforeChange = NULL, OnLangChange_t afterChange = NULL);

private:
	void InitString();
	void AddString(const char * Key, const char * Str);
	void AddString(unsigned int Key, const char * Str);
	CMapString& operator()(const char * Key, const char * Str);

    std::list<OnLangChange_t> m_beChange, m_afChange;
	std::map<std::string, std::string> m_StrMap;
	std::string m_lang;

	void LoadGb2312();
	void LoadEnglish();
};
