#pragma once
#include <string>
#include "IStrSrc.h"
#include <Windows.h>

class StrMangerSing;

class CStrManger
{
private:
	CStrManger();
	friend StrMangerSing;

public:
	virtual ~CStrManger(void);

	void  SetSource(IStrSrc * pSource, bool autodel);

	const std::string& GetString(const std::string& sid);
	const std::string& GetString(unsigned int sid);

	void UpdateControl(HWND hWnd);
	void UpdateMenus(HMENU hMenu);

	void UnUpdateControl(HWND hWnd);
	void UnUpdateMenus(HMENU hMenu);

private:
	static NullStrSrc m_nullstrsrc;
	static BOOL CALLBACK EnumChildProc(HWND hwndChild, LPARAM lParam);

	void UpdateMenuItem(HMENU hMenu, int pos);

	IStrSrc * m_pStrSrc;
	bool	  m_autodel;
	bool	  m_revupte;
};
